#[doc = r" Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - control register 1"]
    pub cr1: CR1,
    #[doc = "0x04 - control register 2"]
    pub cr2: CR2,
    #[doc = "0x08 - interrupt and status register"]
    pub isr: ISR,
    #[doc = "0x0c - interrupt and status clear register"]
    pub clrisr: CLRISR,
    _reserved0: [u8; 4usize],
    #[doc = "0x14 - injected channel group selection register"]
    pub jchgr: JCHGR,
    _reserved1: [u8; 8usize],
    #[doc = "0x20 - configuration 0 register"]
    pub conf0r: CONF0R,
    #[doc = "0x24 - configuration 1 register"]
    pub conf1r: CONF1R,
    #[doc = "0x28 - configuration 2 register"]
    pub conf2r: CONF2R,
    _reserved2: [u8; 20usize],
    #[doc = "0x40 - channel configuration register 1"]
    pub confchr1: CONFCHR1,
    #[doc = "0x44 - channel configuration register 2"]
    pub confchr2: CONFCHR2,
    _reserved3: [u8; 24usize],
    #[doc = "0x60 - data register for injected group"]
    pub jdatar: JDATAR,
    #[doc = "0x64 - data register for the regular channel"]
    pub rdatar: RDATAR,
    _reserved4: [u8; 8usize],
    #[doc = "0x70 - SDADC1 and SDADC2 injected data register"]
    pub jdata12r: JDATA12R,
    #[doc = "0x74 - SDADC1 and SDADC2 regular data register"]
    pub rdata12r: RDATA12R,
    #[doc = "0x78 - SDADC1 and SDADC3 injected data register"]
    pub jdata13r: JDATA13R,
    #[doc = "0x7c - SDADC1 and SDADC3 regular data register"]
    pub rdata13r: RDATA13R,
}
#[doc = "control register 1"]
pub struct CR1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "control register 1"]
pub mod cr1;
#[doc = "control register 2"]
pub struct CR2 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "control register 2"]
pub mod cr2;
#[doc = "interrupt and status register"]
pub struct ISR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "interrupt and status register"]
pub mod isr;
#[doc = "interrupt and status clear register"]
pub struct CLRISR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "interrupt and status clear register"]
pub mod clrisr;
#[doc = "injected channel group selection register"]
pub struct JCHGR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "injected channel group selection register"]
pub mod jchgr;
#[doc = "configuration 0 register"]
pub struct CONF0R {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "configuration 0 register"]
pub mod conf0r;
#[doc = "configuration 1 register"]
pub struct CONF1R {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "configuration 1 register"]
pub mod conf1r;
#[doc = "configuration 2 register"]
pub struct CONF2R {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "configuration 2 register"]
pub mod conf2r;
#[doc = "channel configuration register 1"]
pub struct CONFCHR1 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "channel configuration register 1"]
pub mod confchr1;
#[doc = "channel configuration register 2"]
pub struct CONFCHR2 {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "channel configuration register 2"]
pub mod confchr2;
#[doc = "data register for injected group"]
pub struct JDATAR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "data register for injected group"]
pub mod jdatar;
#[doc = "data register for the regular channel"]
pub struct RDATAR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "data register for the regular channel"]
pub mod rdatar;
#[doc = "SDADC1 and SDADC2 injected data register"]
pub struct JDATA12R {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "SDADC1 and SDADC2 injected data register"]
pub mod jdata12r;
#[doc = "SDADC1 and SDADC2 regular data register"]
pub struct RDATA12R {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "SDADC1 and SDADC2 regular data register"]
pub mod rdata12r;
#[doc = "SDADC1 and SDADC3 injected data register"]
pub struct JDATA13R {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "SDADC1 and SDADC3 injected data register"]
pub mod jdata13r;
#[doc = "SDADC1 and SDADC3 regular data register"]
pub struct RDATA13R {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "SDADC1 and SDADC3 regular data register"]
pub mod rdata13r;
