#[doc = r" Register block"]
#[repr(C)]
pub struct RegisterBlock {
    #[doc = "0x00 - ADC Common status register"]
    pub adc1_csr: ADC1_CSR,
    _reserved0: [u8; 4usize],
    #[doc = "0x08 - ADC common control register"]
    pub adc1_ccr: ADC1_CCR,
    #[doc = "0x0c - ADC common regular data register for dual mode"]
    pub adc1_cdr: ADC1_CDR,
}
#[doc = "ADC Common status register"]
pub struct ADC1_CSR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "ADC Common status register"]
pub mod adc1_csr;
#[doc = "ADC common control register"]
pub struct ADC1_CCR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "ADC common control register"]
pub mod adc1_ccr;
#[doc = "ADC common regular data register for dual mode"]
pub struct ADC1_CDR {
    register: ::vcell::VolatileCell<u32>,
}
#[doc = "ADC common regular data register for dual mode"]
pub mod adc1_cdr;
