#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::AHBRSTR {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = "Possible values of the field `IOPARST`"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum IOPARSTR {
    #[doc = "Reset the selected module"]
    RESET,
    #[doc = r" Reserved"]
    _Reserved(bool),
}
impl IOPARSTR {
    #[doc = r" Returns `true` if the bit is clear (0)"]
    #[inline]
    pub fn bit_is_clear(&self) -> bool {
        !self.bit()
    }
    #[doc = r" Returns `true` if the bit is set (1)"]
    #[inline]
    pub fn bit_is_set(&self) -> bool {
        self.bit()
    }
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bit(&self) -> bool {
        match *self {
            IOPARSTR::RESET => true,
            IOPARSTR::_Reserved(bits) => bits,
        }
    }
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _from(value: bool) -> IOPARSTR {
        match value {
            true => IOPARSTR::RESET,
            i => IOPARSTR::_Reserved(i),
        }
    }
    #[doc = "Checks if the value of the field is `RESET`"]
    #[inline]
    pub fn is_reset(&self) -> bool {
        *self == IOPARSTR::RESET
    }
}
#[doc = "Possible values of the field `IOPBRST`"]
pub type IOPBRSTR = IOPARSTR;
#[doc = "Possible values of the field `IOPCRST`"]
pub type IOPCRSTR = IOPARSTR;
#[doc = "Possible values of the field `IOPDRST`"]
pub type IOPDRSTR = IOPARSTR;
#[doc = "Possible values of the field `IOPERST`"]
pub type IOPERSTR = IOPARSTR;
#[doc = "Possible values of the field `IOPFRST`"]
pub type IOPFRSTR = IOPARSTR;
#[doc = "Possible values of the field `TSCRST`"]
pub type TSCRSTR = IOPARSTR;
#[doc = "Possible values of the field `ADC12RST`"]
pub type ADC12RSTR = IOPARSTR;
#[doc = "Possible values of the field `ADC34RST`"]
pub type ADC34RSTR = IOPARSTR;
#[doc = "Values that can be written to the field `IOPARST`"]
pub enum IOPARSTW {
    #[doc = "Reset the selected module"]
    RESET,
}
impl IOPARSTW {
    #[allow(missing_docs)]
    #[doc(hidden)]
    #[inline]
    pub fn _bits(&self) -> bool {
        match *self {
            IOPARSTW::RESET => true,
        }
    }
}
#[doc = r" Proxy"]
pub struct _IOPARSTW<'a> {
    w: &'a mut W,
}
impl<'a> _IOPARSTW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: IOPARSTW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Reset the selected module"]
    #[inline]
    pub fn reset(self) -> &'a mut W {
        self.variant(IOPARSTW::RESET)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 17;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `IOPBRST`"]
pub type IOPBRSTW = IOPARSTW;
#[doc = r" Proxy"]
pub struct _IOPBRSTW<'a> {
    w: &'a mut W,
}
impl<'a> _IOPBRSTW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: IOPBRSTW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Reset the selected module"]
    #[inline]
    pub fn reset(self) -> &'a mut W {
        self.variant(IOPARSTW::RESET)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 18;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `IOPCRST`"]
pub type IOPCRSTW = IOPARSTW;
#[doc = r" Proxy"]
pub struct _IOPCRSTW<'a> {
    w: &'a mut W,
}
impl<'a> _IOPCRSTW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: IOPCRSTW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Reset the selected module"]
    #[inline]
    pub fn reset(self) -> &'a mut W {
        self.variant(IOPARSTW::RESET)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 19;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `IOPDRST`"]
pub type IOPDRSTW = IOPARSTW;
#[doc = r" Proxy"]
pub struct _IOPDRSTW<'a> {
    w: &'a mut W,
}
impl<'a> _IOPDRSTW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: IOPDRSTW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Reset the selected module"]
    #[inline]
    pub fn reset(self) -> &'a mut W {
        self.variant(IOPARSTW::RESET)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 20;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `IOPERST`"]
pub type IOPERSTW = IOPARSTW;
#[doc = r" Proxy"]
pub struct _IOPERSTW<'a> {
    w: &'a mut W,
}
impl<'a> _IOPERSTW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: IOPERSTW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Reset the selected module"]
    #[inline]
    pub fn reset(self) -> &'a mut W {
        self.variant(IOPARSTW::RESET)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 21;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `IOPFRST`"]
pub type IOPFRSTW = IOPARSTW;
#[doc = r" Proxy"]
pub struct _IOPFRSTW<'a> {
    w: &'a mut W,
}
impl<'a> _IOPFRSTW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: IOPFRSTW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Reset the selected module"]
    #[inline]
    pub fn reset(self) -> &'a mut W {
        self.variant(IOPARSTW::RESET)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 22;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `TSCRST`"]
pub type TSCRSTW = IOPARSTW;
#[doc = r" Proxy"]
pub struct _TSCRSTW<'a> {
    w: &'a mut W,
}
impl<'a> _TSCRSTW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: TSCRSTW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Reset the selected module"]
    #[inline]
    pub fn reset(self) -> &'a mut W {
        self.variant(IOPARSTW::RESET)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 24;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `ADC12RST`"]
pub type ADC12RSTW = IOPARSTW;
#[doc = r" Proxy"]
pub struct _ADC12RSTW<'a> {
    w: &'a mut W,
}
impl<'a> _ADC12RSTW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: ADC12RSTW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Reset the selected module"]
    #[inline]
    pub fn reset(self) -> &'a mut W {
        self.variant(IOPARSTW::RESET)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 28;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = "Values that can be written to the field `ADC34RST`"]
pub type ADC34RSTW = IOPARSTW;
#[doc = r" Proxy"]
pub struct _ADC34RSTW<'a> {
    w: &'a mut W,
}
impl<'a> _ADC34RSTW<'a> {
    #[doc = r" Writes `variant` to the field"]
    #[inline]
    pub fn variant(self, variant: ADC34RSTW) -> &'a mut W {
        {
            self.bit(variant._bits())
        }
    }
    #[doc = "Reset the selected module"]
    #[inline]
    pub fn reset(self) -> &'a mut W {
        self.variant(IOPARSTW::RESET)
    }
    #[doc = r" Sets the field bit"]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r" Clears the field bit"]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub fn bit(self, value: bool) -> &'a mut W {
        const MASK: bool = true;
        const OFFSET: u8 = 29;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bit 17 - I/O port A reset"]
    #[inline]
    pub fn ioparst(&self) -> IOPARSTR {
        IOPARSTR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 17;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 18 - I/O port B reset"]
    #[inline]
    pub fn iopbrst(&self) -> IOPBRSTR {
        IOPBRSTR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 18;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 19 - I/O port C reset"]
    #[inline]
    pub fn iopcrst(&self) -> IOPCRSTR {
        IOPCRSTR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 19;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 20 - I/O port D reset"]
    #[inline]
    pub fn iopdrst(&self) -> IOPDRSTR {
        IOPDRSTR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 20;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 21 - I/O port E reset"]
    #[inline]
    pub fn ioperst(&self) -> IOPERSTR {
        IOPERSTR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 21;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 22 - I/O port F reset"]
    #[inline]
    pub fn iopfrst(&self) -> IOPFRSTR {
        IOPFRSTR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 22;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 24 - Touch sensing controller reset"]
    #[inline]
    pub fn tscrst(&self) -> TSCRSTR {
        TSCRSTR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 24;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 28 - ADC1 and ADC2 reset"]
    #[inline]
    pub fn adc12rst(&self) -> ADC12RSTR {
        ADC12RSTR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 28;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
    #[doc = "Bit 29 - ADC3 and ADC4 reset"]
    #[inline]
    pub fn adc34rst(&self) -> ADC34RSTR {
        ADC34RSTR::_from({
            const MASK: bool = true;
            const OFFSET: u8 = 29;
            ((self.bits >> OFFSET) & MASK as u32) != 0
        })
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bit 17 - I/O port A reset"]
    #[inline]
    pub fn ioparst(&mut self) -> _IOPARSTW {
        _IOPARSTW { w: self }
    }
    #[doc = "Bit 18 - I/O port B reset"]
    #[inline]
    pub fn iopbrst(&mut self) -> _IOPBRSTW {
        _IOPBRSTW { w: self }
    }
    #[doc = "Bit 19 - I/O port C reset"]
    #[inline]
    pub fn iopcrst(&mut self) -> _IOPCRSTW {
        _IOPCRSTW { w: self }
    }
    #[doc = "Bit 20 - I/O port D reset"]
    #[inline]
    pub fn iopdrst(&mut self) -> _IOPDRSTW {
        _IOPDRSTW { w: self }
    }
    #[doc = "Bit 21 - I/O port E reset"]
    #[inline]
    pub fn ioperst(&mut self) -> _IOPERSTW {
        _IOPERSTW { w: self }
    }
    #[doc = "Bit 22 - I/O port F reset"]
    #[inline]
    pub fn iopfrst(&mut self) -> _IOPFRSTW {
        _IOPFRSTW { w: self }
    }
    #[doc = "Bit 24 - Touch sensing controller reset"]
    #[inline]
    pub fn tscrst(&mut self) -> _TSCRSTW {
        _TSCRSTW { w: self }
    }
    #[doc = "Bit 28 - ADC1 and ADC2 reset"]
    #[inline]
    pub fn adc12rst(&mut self) -> _ADC12RSTW {
        _ADC12RSTW { w: self }
    }
    #[doc = "Bit 29 - ADC3 and ADC4 reset"]
    #[inline]
    pub fn adc34rst(&mut self) -> _ADC34RSTW {
        _ADC34RSTW { w: self }
    }
}
