#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::CONFCHR1 {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = r" Value of the field"]
pub struct CONFCH7R {
    bits: u8,
}
impl CONFCH7R {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r" Value of the field"]
pub struct CONFCH6R {
    bits: u8,
}
impl CONFCH6R {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r" Value of the field"]
pub struct CONFCH5R {
    bits: u8,
}
impl CONFCH5R {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r" Value of the field"]
pub struct CONFCH4R {
    bits: u8,
}
impl CONFCH4R {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r" Value of the field"]
pub struct CONFCH3R {
    bits: u8,
}
impl CONFCH3R {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r" Value of the field"]
pub struct CONFCH2R {
    bits: u8,
}
impl CONFCH2R {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r" Value of the field"]
pub struct CONFCH1R {
    bits: u8,
}
impl CONFCH1R {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r" Value of the field"]
pub struct CONFCH0R {
    bits: u8,
}
impl CONFCH0R {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r" Proxy"]
pub struct _CONFCH7W<'a> {
    w: &'a mut W,
}
impl<'a> _CONFCH7W<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 28;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _CONFCH6W<'a> {
    w: &'a mut W,
}
impl<'a> _CONFCH6W<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 24;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _CONFCH5W<'a> {
    w: &'a mut W,
}
impl<'a> _CONFCH5W<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 20;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _CONFCH4W<'a> {
    w: &'a mut W,
}
impl<'a> _CONFCH4W<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 16;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _CONFCH3W<'a> {
    w: &'a mut W,
}
impl<'a> _CONFCH3W<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 12;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _CONFCH2W<'a> {
    w: &'a mut W,
}
impl<'a> _CONFCH2W<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 8;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _CONFCH1W<'a> {
    w: &'a mut W,
}
impl<'a> _CONFCH1W<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 4;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _CONFCH0W<'a> {
    w: &'a mut W,
}
impl<'a> _CONFCH0W<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bits 28:29 - CONFCH7"]
    #[inline]
    pub fn confch7(&self) -> CONFCH7R {
        let bits = {
            const MASK: u8 = 3;
            const OFFSET: u8 = 28;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        };
        CONFCH7R { bits }
    }
    #[doc = "Bits 24:25 - CONFCH6"]
    #[inline]
    pub fn confch6(&self) -> CONFCH6R {
        let bits = {
            const MASK: u8 = 3;
            const OFFSET: u8 = 24;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        };
        CONFCH6R { bits }
    }
    #[doc = "Bits 20:21 - CONFCH5"]
    #[inline]
    pub fn confch5(&self) -> CONFCH5R {
        let bits = {
            const MASK: u8 = 3;
            const OFFSET: u8 = 20;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        };
        CONFCH5R { bits }
    }
    #[doc = "Bits 16:17 - CONFCH4"]
    #[inline]
    pub fn confch4(&self) -> CONFCH4R {
        let bits = {
            const MASK: u8 = 3;
            const OFFSET: u8 = 16;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        };
        CONFCH4R { bits }
    }
    #[doc = "Bits 12:13 - CONFCH3"]
    #[inline]
    pub fn confch3(&self) -> CONFCH3R {
        let bits = {
            const MASK: u8 = 3;
            const OFFSET: u8 = 12;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        };
        CONFCH3R { bits }
    }
    #[doc = "Bits 8:9 - CONFCH2"]
    #[inline]
    pub fn confch2(&self) -> CONFCH2R {
        let bits = {
            const MASK: u8 = 3;
            const OFFSET: u8 = 8;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        };
        CONFCH2R { bits }
    }
    #[doc = "Bits 4:5 - CONFCH1"]
    #[inline]
    pub fn confch1(&self) -> CONFCH1R {
        let bits = {
            const MASK: u8 = 3;
            const OFFSET: u8 = 4;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        };
        CONFCH1R { bits }
    }
    #[doc = "Bits 0:1 - CONFCH0"]
    #[inline]
    pub fn confch0(&self) -> CONFCH0R {
        let bits = {
            const MASK: u8 = 3;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        };
        CONFCH0R { bits }
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bits 28:29 - CONFCH7"]
    #[inline]
    pub fn confch7(&mut self) -> _CONFCH7W {
        _CONFCH7W { w: self }
    }
    #[doc = "Bits 24:25 - CONFCH6"]
    #[inline]
    pub fn confch6(&mut self) -> _CONFCH6W {
        _CONFCH6W { w: self }
    }
    #[doc = "Bits 20:21 - CONFCH5"]
    #[inline]
    pub fn confch5(&mut self) -> _CONFCH5W {
        _CONFCH5W { w: self }
    }
    #[doc = "Bits 16:17 - CONFCH4"]
    #[inline]
    pub fn confch4(&mut self) -> _CONFCH4W {
        _CONFCH4W { w: self }
    }
    #[doc = "Bits 12:13 - CONFCH3"]
    #[inline]
    pub fn confch3(&mut self) -> _CONFCH3W {
        _CONFCH3W { w: self }
    }
    #[doc = "Bits 8:9 - CONFCH2"]
    #[inline]
    pub fn confch2(&mut self) -> _CONFCH2W {
        _CONFCH2W { w: self }
    }
    #[doc = "Bits 4:5 - CONFCH1"]
    #[inline]
    pub fn confch1(&mut self) -> _CONFCH1W {
        _CONFCH1W { w: self }
    }
    #[doc = "Bits 0:1 - CONFCH0"]
    #[inline]
    pub fn confch0(&mut self) -> _CONFCH0W {
        _CONFCH0W { w: self }
    }
}
