#[doc = r" Value read from the register"]
pub struct R {
    bits: u32,
}
#[doc = r" Value to write to the register"]
pub struct W {
    bits: u32,
}
impl super::CFGR3 {
    #[doc = r" Modifies the contents of the register"]
    #[inline]
    pub fn modify<F>(&self, f: F)
    where
        for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W,
    {
        let bits = self.register.get();
        let r = R { bits: bits };
        let mut w = W { bits: bits };
        f(&r, &mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Reads the contents of the register"]
    #[inline]
    pub fn read(&self) -> R {
        R {
            bits: self.register.get(),
        }
    }
    #[doc = r" Writes to the register"]
    #[inline]
    pub fn write<F>(&self, f: F)
    where
        F: FnOnce(&mut W) -> &mut W,
    {
        let mut w = W::reset_value();
        f(&mut w);
        self.register.set(w.bits);
    }
    #[doc = r" Writes the reset value to the register"]
    #[inline]
    pub fn reset(&self) {
        self.write(|w| w)
    }
}
#[doc = r" Value of the field"]
pub struct I2C1_RX_DMA_RMPR {
    bits: u8,
}
impl I2C1_RX_DMA_RMPR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r" Value of the field"]
pub struct SPI1_TX_DMA_RMPR {
    bits: u8,
}
impl SPI1_TX_DMA_RMPR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r" Value of the field"]
pub struct SPI1_RX_DMA_RMPR {
    bits: u8,
}
impl SPI1_RX_DMA_RMPR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r" Value of the field"]
pub struct I2C1_TX_DMA_RMPR {
    bits: u8,
}
impl I2C1_TX_DMA_RMPR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r" Value of the field"]
pub struct ADC2_DMA_RMPR {
    bits: u8,
}
impl ADC2_DMA_RMPR {
    #[doc = r" Value of the field as raw bits"]
    #[inline]
    pub fn bits(&self) -> u8 {
        self.bits
    }
}
#[doc = r" Proxy"]
pub struct _I2C1_RX_DMA_RMPW<'a> {
    w: &'a mut W,
}
impl<'a> _I2C1_RX_DMA_RMPW<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 4;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _SPI1_TX_DMA_RMPW<'a> {
    w: &'a mut W,
}
impl<'a> _SPI1_TX_DMA_RMPW<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 2;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _SPI1_RX_DMA_RMPW<'a> {
    w: &'a mut W,
}
impl<'a> _SPI1_RX_DMA_RMPW<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 0;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _I2C1_TX_DMA_RMPW<'a> {
    w: &'a mut W,
}
impl<'a> _I2C1_TX_DMA_RMPW<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 6;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
#[doc = r" Proxy"]
pub struct _ADC2_DMA_RMPW<'a> {
    w: &'a mut W,
}
impl<'a> _ADC2_DMA_RMPW<'a> {
    #[doc = r" Writes raw bits to the field"]
    #[inline]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        const MASK: u8 = 3;
        const OFFSET: u8 = 8;
        self.w.bits &= !((MASK as u32) << OFFSET);
        self.w.bits |= ((value & MASK) as u32) << OFFSET;
        self.w
    }
}
impl R {
    #[doc = r" Value of the register as raw bits"]
    #[inline]
    pub fn bits(&self) -> u32 {
        self.bits
    }
    #[doc = "Bits 4:5 - I2C1_RX DMA remapping bit"]
    #[inline]
    pub fn i2c1_rx_dma_rmp(&self) -> I2C1_RX_DMA_RMPR {
        let bits = {
            const MASK: u8 = 3;
            const OFFSET: u8 = 4;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        };
        I2C1_RX_DMA_RMPR { bits }
    }
    #[doc = "Bits 2:3 - SPI1_TX DMA remapping bit"]
    #[inline]
    pub fn spi1_tx_dma_rmp(&self) -> SPI1_TX_DMA_RMPR {
        let bits = {
            const MASK: u8 = 3;
            const OFFSET: u8 = 2;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        };
        SPI1_TX_DMA_RMPR { bits }
    }
    #[doc = "Bits 0:1 - SPI1_RX DMA remapping bit"]
    #[inline]
    pub fn spi1_rx_dma_rmp(&self) -> SPI1_RX_DMA_RMPR {
        let bits = {
            const MASK: u8 = 3;
            const OFFSET: u8 = 0;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        };
        SPI1_RX_DMA_RMPR { bits }
    }
    #[doc = "Bits 6:7 - I2C1_TX DMA remapping bit"]
    #[inline]
    pub fn i2c1_tx_dma_rmp(&self) -> I2C1_TX_DMA_RMPR {
        let bits = {
            const MASK: u8 = 3;
            const OFFSET: u8 = 6;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        };
        I2C1_TX_DMA_RMPR { bits }
    }
    #[doc = "Bits 8:9 - ADC2 DMA remapping bit"]
    #[inline]
    pub fn adc2_dma_rmp(&self) -> ADC2_DMA_RMPR {
        let bits = {
            const MASK: u8 = 3;
            const OFFSET: u8 = 8;
            ((self.bits >> OFFSET) & MASK as u32) as u8
        };
        ADC2_DMA_RMPR { bits }
    }
}
impl W {
    #[doc = r" Reset value of the register"]
    #[inline]
    pub fn reset_value() -> W {
        W { bits: 0 }
    }
    #[doc = r" Writes raw bits to the register"]
    #[inline]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.bits = bits;
        self
    }
    #[doc = "Bits 4:5 - I2C1_RX DMA remapping bit"]
    #[inline]
    pub fn i2c1_rx_dma_rmp(&mut self) -> _I2C1_RX_DMA_RMPW {
        _I2C1_RX_DMA_RMPW { w: self }
    }
    #[doc = "Bits 2:3 - SPI1_TX DMA remapping bit"]
    #[inline]
    pub fn spi1_tx_dma_rmp(&mut self) -> _SPI1_TX_DMA_RMPW {
        _SPI1_TX_DMA_RMPW { w: self }
    }
    #[doc = "Bits 0:1 - SPI1_RX DMA remapping bit"]
    #[inline]
    pub fn spi1_rx_dma_rmp(&mut self) -> _SPI1_RX_DMA_RMPW {
        _SPI1_RX_DMA_RMPW { w: self }
    }
    #[doc = "Bits 6:7 - I2C1_TX DMA remapping bit"]
    #[inline]
    pub fn i2c1_tx_dma_rmp(&mut self) -> _I2C1_TX_DMA_RMPW {
        _I2C1_TX_DMA_RMPW { w: self }
    }
    #[doc = "Bits 8:9 - ADC2 DMA remapping bit"]
    #[inline]
    pub fn adc2_dma_rmp(&mut self) -> _ADC2_DMA_RMPW {
        _ADC2_DMA_RMPW { w: self }
    }
}
